// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_authentication_bloc/src/domain/entities/account.dart';

abstract class AuthChangeEvent {
  AuthChangeEvent(this.account);

  final Account? account;
}

class SignInAuthChangeEvent extends AuthChangeEvent {
  SignInAuthChangeEvent(super.account);
}

class SignUpAuthChangeEvent extends AuthChangeEvent {
  SignUpAuthChangeEvent(super.account);
}

class RefreshAuthChangeEvent extends AuthChangeEvent {
  RefreshAuthChangeEvent(super.account);
}

class StillUnauthenticatedAuthChangeEvent extends AuthChangeEvent {
  StillUnauthenticatedAuthChangeEvent() : super(null);
}

class SignOutAuthChangeEvent extends AuthChangeEvent {
  SignOutAuthChangeEvent() : super(null);
}
